//+-----------------------------------------------------------------------+
//|Expert Advisor based on the Movings Averages, RAVI and CountCandle.mq4 |
//|                                                    Andrey and Vasiliy |
//|                           passivusnet@yandex.ru and vasssay@yandex.ru |
//+-----------------------------------------------------------------------+
#property copyright "Andrey and Vasiliy"
#property link      "passivusnet@yandex.ru, vasssay@yandex.ru"

//  Moving Average     
extern int period1    = 55;//     
extern int ma_shift1  = 0;  //    
extern int ma_method1 = MODE_SMA;// .      
/*
0    
1    
2    
3 -   
*/
extern int applied_price1=PRICE_CLOSE ;// .     
/*
0   
1   
2   
3   
4  , (high+low)/2 
5  , (high+low+close)/3 
6   , (high+low+close+close)/4 
*/

//  Moving Average     
extern int period2    = 200;//     
extern int ma_shift2  = 0;  //    
extern int ma_method2 = MODE_SMA;// .      
/*
0    
1    
2    
3 -   
*/
extern int applied_price2=PRICE_CLOSE ;// .     
/*
0   
1   
2   
3   
4  , (high+low)/2 
5  , (high+low+close)/3 
6   , (high+low+close+close)/4 
*/



extern int take = 50;//   0  
extern int loss = 50;//   0   
double _loss,_take;

extern double lot = 0.10;//  
extern int    key = 1234;//MagicNumber
int slip=10;//Slippage

extern bool usetrailing = true; // true-  ,  false -   
extern int trailingstop=15;     //   
extern int tralStep=5;//   
 
//  RAVI
extern int CountCandle=10;//  ,    ,   Movings Averages
extern bool useRavi = true;//  Ravi true - , false - 
extern int PeriodRavi1=7; 
extern int PeriodRavi2=65; 
extern double levelFlet=0.01;// +/-      ,    



int start()
  { 
  
  double cl = iClose(Symbol(),0,1);
  if(period1==period2)
    {
     Alert("  .  ");
     return(0);
    } 
  //,   
 int signal=0;
 for(int c=0;c<=CountCandle;c++)
 { 
  double _ma1= iMA(Symbol(),0,period1,ma_shift1,ma_method1,applied_price1,c+1);
  double _ma2= iMA(Symbol(),0,period2,ma_shift2,ma_method2,applied_price2,c+1);
  double _ma10= iMA(Symbol(),0,period1,ma_shift1,ma_method1,applied_price1,c);  
  double _ma20= iMA(Symbol(),0,period2,ma_shift2,ma_method2,applied_price2,c);  
  
  
  
  //   Moving Average
  if(period1<period2)
    {
    double ma1=_ma1;
    double ma10=_ma10;
    double ma2=_ma2;
    double ma20=_ma20;
    }
  if(period1>period2)
    {
           ma1=_ma2;
           ma10=_ma20;
           ma2=_ma1;
           ma20=_ma10;
    }
  
  // 
  
  if(ma1<ma2 && ma20<=ma10)
    
        signal=1; 
   if(ma1>ma2 && ma20>=ma10)
    
        signal=-1; 
  if(signal!=0)break;      
 }
 
 double ravi=iCustom(Symbol(),0,"RAVI",PeriodRavi1,PeriodRavi2,0,0);     
 //
   if(totalO(-1,key)==0 && signal==1)
     {
     if((useRavi && (ravi>levelFlet || ravi<levelFlet*(-1)))||!useRavi)
      {
       if(getOpenClose()>c || getOpenClose()==-1)
        {  
         if(take==0)_take=0;
         if(take!=0)_take=ND(Ask+take*Point);
         if(loss==0)_loss=0;
         if(loss!=0)_loss=ND(Ask-loss*Point);
         openorder(OP_BUY,lot,slip,ND(Ask),_loss,_take,key); 
        }
      }
     }
   if(totalO(-1,key)==0 && signal==-1)
     {
     if((useRavi && (ravi>levelFlet || ravi<levelFlet*(-1)))||!useRavi)
      {
       if(getOpenClose()>c || getOpenClose()==-1)
        {
         if(take==0)_take=0;
         if(take!=0)_take=ND(Bid-take*Point);
         if(loss==0)_loss=0;
         if(loss!=0)_loss=ND(Bid+loss*Point);
         openorder(OP_SELL,lot,slip,ND(Bid),_loss,_take,key); 
        }
      } 
     }
  //   
   if(totalO(0,key)==1 && signal==-1)
     close_working(key,0);   
   if(totalO(1,key)==1 && signal==1)
     close_working(key,1);   
  
  //
  Trail(key);

   return(0);
  }
//+------------------------------------------------------------------+

//
void Trail(int _key)
{  
   for(int i=0; i<OrdersTotal(); i++)
      if (OrderSelect(i,SELECT_BY_POS) && OrderSymbol()==Symbol() && OrderMagicNumber()==_key)
      {
         if (OrderType()==OP_BUY && ND(Bid)>MathMax(OrderOpenPrice(),OrderStopLoss())+(trailingstop+tralStep)*Point)
              if (!OrderModify(OrderTicket(),OrderOpenPrice(),ND(Bid)-trailingstop*Point,OrderTakeProfit(),0))
              {}
         if (OrderType()==OP_SELL && ((ND(Ask)<MathMin(OrderOpenPrice(),OrderStopLoss())-(trailingstop+tralStep)*Point && OrderStopLoss()!=0)||(ND(Ask)<OrderOpenPrice()-(trailingstop+tralStep)*Point && OrderStopLoss()==0)))
            if (!OrderModify(OrderTicket(),OrderOpenPrice(),ND(Ask)+trailingstop*Point,OrderTakeProfit(),0))
               {}
      }
}

//    
double ND(double price)
{
return(NormalizeDouble(price,Digits));
} 

//1.     
/*  
 
int type (if -1 all type)
OP_BUY 0  
OP_SELL 1  
OP_BUYLIMIT 2   BUY LIMIT 
OP_SELLLIMIT 3   SELL LIMIT 
OP_BUYSTOP 4   BUY STOP 
OP_SELLSTOP 5   SELL STOP 
int _key MagicNumber

*/
int totalO(int type,int _key)
 {
       int TotalNumber = 0;  
              for(int i=0; i<OrdersTotal(); i++)
                {  
                  if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)||OrderSymbol() !=Symbol()|| OrderMagicNumber()!=_key) continue; 
                  if (OrderType()==type||type==-1){
                  TotalNumber++;}
                } 
              return(TotalNumber); 
 }
/* 

int type =   
OP_BUY 0  
OP_SELL 1  
OP_BUYLIMIT 2   BUY LIMIT 
OP_SELLLIMIT 3   SELL LIMIT 
OP_BUYSTOP 4   BUY STOP 
OP_SELLSTOP 5   SELL STOP 
double lot   - volume
int    slip  - slippage
double price - open price
int _loss - stoploos if =0 do not Set
int _take - takeprofit if =0 do not Set
int _key  - MagicNumber 
*/
void openorder(int type,double lot,int slip,double price,double _loss, double _take,int key)
{
 color col=Blue;
 if(type==1 || type==3 ||type==5) col=Red;
 
 
         int tik=OrderSend(Symbol(),type,lot,price,slip,0,0,"expert",key,0,col);
         if(tik!=-1 && (_loss!=0 ||_take!=0) ){
         OrderSelect(tik,SELECT_BY_TICKET,MODE_TRADES);
         OrderModify(tik,OrderOpenPrice(),_loss,_take,0,col);
          if(GetLastError()!=0)
         Print("  "+GetLastError()," t=",tik  ," P=",OrderOpenPrice()," s=",_loss," t=",_take); 
          }
         
         
         if(tik==-1){
         Print(" "+GetLastError()," t=",type," P=",price," s=",_loss," t=",_take ," level=",MarketInfo(Symbol(),MODE_STOPLEVEL)," bid ",Bid," ask ",Ask);
         Sleep(1000);}
        
         
}  

 ///   
/*
 
int type   = -1  
int type (if -1 all type)
OP_BUY 0  
OP_SELL 1  
OP_BUYLIMIT 2   BUY LIMIT 
OP_SELLLIMIT 3   SELL LIMIT 
OP_BUYSTOP 4   BUY STOP 
OP_SELLSTOP 5   SELL STOP 
int _key MagicNumber
*/

void close_working(int _key, int type)
{
int kol=OrdersTotal();
for (int i=kol; i>=0; i--)
   {
   while(!IsTradeAllowed()) Sleep(1000);
   //Print(i," ",OrderSelect(i,SELECT_BY_POS,MODE_TRADES) ," ",OrderTicket()," ",kol);
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol() == Symbol() && OrderMagicNumber()==_key && (OrderType()==type || type==-1)  ){ 
      if (OrderType()==OP_BUY ) OrderClose (OrderTicket(),OrderLots(),ND(Bid),slip);
      if (OrderType()==OP_SELL) OrderClose (OrderTicket(),OrderLots(),ND(Ask),slip);
      if (OrderType()>1 ) OrderDelete(OrderTicket(),CLR_NONE);
      if(GetLastError()!=0)Print("  =",GetLastError());
   }
   
}
}   

//      
int getOpenClose()
{
  int can = -1;  
              for(int i=OrdersHistoryTotal(); i>=0; i--)
                {  
                  if (!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)||OrderSymbol() !=Symbol()|| OrderMagicNumber()!=key || OrderType()>1) continue; 
                  can=iBarShift(Symbol(),0,OrderOpenTime());                
                  break;
                } 
              return(can);      
}              